# Create an alert

Endpoint: POST /v1alpha/alerts
Version: v1alpha
Security: oauth2_client_credentials, oauth2_authorization_code

## Security:

  - `oauth2_client_credentials` (unknown)
    oauth2

  - `oauth2_authorization_code` (unknown)
    oauth2

## Query parameters:

  - `alertId` (string)
    A client-assigned identifier for the alert. If provided, it must be
 a valid [AIP-122](https://google.aip.dev/122) resource ID. If not
 provided, a server-generated identifier is used.

## Request body:

  - `application/json` (unknown)
    Required. The alert to create.

## Request fields (application/json):

  - `name` (string)
    (IDENTIFIER) The resource name of the alert.
Format: alerts/{alert}
string.resource_name = ["alerts/*"] // value must be a valid resource name

  - `alertType` (string, required)
    Required. The type of the alert.
Format: alertTypes/{alert_type}
string.resource_name = ["alertTypes/*"] // value must be a valid resource name

  - `message` (string)
    (OPTIONAL) Optional. A description of what triggered the alert.

  - `source` (string, required)
    The external system that generated the Alert, populated when the Alert originates outside of BNDRY. Null for internally generated Alerts.
 eg: Transaction Monitoring, Cherrycheck, Webhook etc.
    Enum: "ALERT_SOURCE_UNSPECIFIED", "BNDRY", "TRANSACTION_MONITORING"

  - `state` (string)
    State of the alert
    Enum: "STATE_UNSPECIFIED", "OPEN", "ACKNOWLEDGED", "RESOLVED"

  - `entities` (array)
    (OPTIONAL) Optional. The entities involved in this alert.

  - `workspace` (string)
    (OPTIONAL) Optional. The workspace involved in this alert.
string.resource_name = ["workspaces/*"] // value must be a valid resource name

  - `formDefinition` (string)
    (OPTIONAL) Optional. Form Definition associated with the created form
If both this and form is sent, they must match.
If form is sent but this is not, it gets auto-populated
string.resource_name = ["formDefinitions/*"] // value must be a valid resource name

  - `form` (string)
    (OPTIONAL) Optional. The form involved in this alert.
If both this and form_definition is sent, they must match.
If form_definition is sent but this is not, it gets auto-populated
string.resource_name = ["forms/*", "workspaces/*/forms/*"] // value must be a valid resource name

  - `annotations` (object)
    (OPTIONAL) Optional key value annotations.

  - `createTime` (string)
    A Timestamp represents a point in time independent of any time zone or local
calendar, encoded as a count of seconds and fractions of seconds at
nanosecond resolution. The count is relative to an epoch at UTC midnight on
January 1, 1970, in the proleptic Gregorian calendar which extends the
Gregorian calendar backwards to year one.
All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap
second table is needed for interpretation, using a [24-hour linear
smear](https://developers.google.com/time/smear).
The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By
restricting to that range, we ensure that we can convert to and from [RFC
3339](https://www.ietf.org/rfc/rfc3339.txt) date strings.
# Examples
Example 1: Compute Timestamp from POSIX `time()`.
Timestamp timestamp;
timestamp.set_seconds(time(NULL));
timestamp.set_nanos(0);
Example 2: Compute Timestamp from POSIX `gettimeofday()`.
struct timeval tv;
gettimeofday(&tv, NULL);
Timestamp timestamp;
timestamp.set_seconds(tv.tv_sec);
timestamp.set_nanos(tv.tv_usec * 1000);
Example 3: Compute Timestamp from Win32 `GetSystemTimeAsFileTime()`.
FILETIME ft;
GetSystemTimeAsFileTime(&ft);
UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime;
// A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z
// is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z.
Timestamp timestamp;
timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL));
timestamp.set_nanos((INT32) ((ticks % 10000000) * 100));
Example 4: Compute Timestamp from Java `System.currentTimeMillis()`.
long millis = System.currentTimeMillis();
Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000)
.setNanos((int) ((millis % 1000) * 1000000)).build();
Example 5: Compute Timestamp from Java `Instant.now()`.
Instant now = Instant.now();
Timestamp timestamp =
Timestamp.newBuilder().setSeconds(now.getEpochSecond())
.setNanos(now.getNano()).build();
Example 6: Compute Timestamp from current time in Python.
timestamp = Timestamp()
timestamp.GetCurrentTime()
# JSON Mapping
In JSON format, the Timestamp type is encoded as a string in the
[RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format. That is, the
format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z"
where {year} is always expressed using four digits while {month}, {day},
{hour}, {min}, and {sec} are zero-padded to two digits each. The fractional
seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution),
are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone
is required. A proto3 JSON serializer should always use UTC (as indicated by
"Z") when printing the Timestamp type and a proto3 JSON parser should be
able to accept both UTC and other timezones (as indicated by an offset).
For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past
01:30 UTC on January 15, 2017.
In JavaScript, one can convert a Date object to this format using the
standard
[toISOString()](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/toISOString)
method. In Python, a standard `datetime.datetime` object can be converted
to this format using
[`strftime`](https://docs.python.org/2/library/time.html#time.strftime) with
the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use
the Joda Time's [`ISODateTimeFormat.dateTime()`](http://joda-time.sourceforge.net/apidocs/org/joda/time/format/ISODateTimeFormat.html#dateTime()) to obtain a formatter capable of generating timestamps in this format.

## Response 200:

  - `200` (unknown)
    Success

## Response 200 fields (application/json):

  - `name` (string)
    (IDENTIFIER) The resource name of the alert.
Format: alerts/{alert}
string.resource_name = ["alerts/*"] // value must be a valid resource name

  - `alertType` (string, required)
    Required. The type of the alert.
Format: alertTypes/{alert_type}
string.resource_name = ["alertTypes/*"] // value must be a valid resource name

  - `message` (string)
    (OPTIONAL) Optional. A description of what triggered the alert.

  - `source` (string, required)
    The external system that generated the Alert, populated when the Alert originates outside of BNDRY. Null for internally generated Alerts.
 eg: Transaction Monitoring, Cherrycheck, Webhook etc.
    Enum: "ALERT_SOURCE_UNSPECIFIED", "BNDRY", "TRANSACTION_MONITORING"

  - `state` (string)
    State of the alert
    Enum: "STATE_UNSPECIFIED", "OPEN", "ACKNOWLEDGED", "RESOLVED"

  - `entities` (array)
    (OPTIONAL) Optional. The entities involved in this alert.

  - `workspace` (string)
    (OPTIONAL) Optional. The workspace involved in this alert.
string.resource_name = ["workspaces/*"] // value must be a valid resource name

  - `formDefinition` (string)
    (OPTIONAL) Optional. Form Definition associated with the created form
If both this and form is sent, they must match.
If form is sent but this is not, it gets auto-populated
string.resource_name = ["formDefinitions/*"] // value must be a valid resource name

  - `form` (string)
    (OPTIONAL) Optional. The form involved in this alert.
If both this and form_definition is sent, they must match.
If form_definition is sent but this is not, it gets auto-populated
string.resource_name = ["forms/*", "workspaces/*/forms/*"] // value must be a valid resource name

  - `annotations` (object)
    (OPTIONAL) Optional key value annotations.

  - `createTime` (string)
    A Timestamp represents a point in time independent of any time zone or local
calendar, encoded as a count of seconds and fractions of seconds at
nanosecond resolution. The count is relative to an epoch at UTC midnight on
January 1, 1970, in the proleptic Gregorian calendar which extends the
Gregorian calendar backwards to year one.
All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap
second table is needed for interpretation, using a [24-hour linear
smear](https://developers.google.com/time/smear).
The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By
restricting to that range, we ensure that we can convert to and from [RFC
3339](https://www.ietf.org/rfc/rfc3339.txt) date strings.
# Examples
Example 1: Compute Timestamp from POSIX `time()`.
Timestamp timestamp;
timestamp.set_seconds(time(NULL));
timestamp.set_nanos(0);
Example 2: Compute Timestamp from POSIX `gettimeofday()`.
struct timeval tv;
gettimeofday(&tv, NULL);
Timestamp timestamp;
timestamp.set_seconds(tv.tv_sec);
timestamp.set_nanos(tv.tv_usec * 1000);
Example 3: Compute Timestamp from Win32 `GetSystemTimeAsFileTime()`.
FILETIME ft;
GetSystemTimeAsFileTime(&ft);
UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime;
// A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z
// is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z.
Timestamp timestamp;
timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL));
timestamp.set_nanos((INT32) ((ticks % 10000000) * 100));
Example 4: Compute Timestamp from Java `System.currentTimeMillis()`.
long millis = System.currentTimeMillis();
Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000)
.setNanos((int) ((millis % 1000) * 1000000)).build();
Example 5: Compute Timestamp from Java `Instant.now()`.
Instant now = Instant.now();
Timestamp timestamp =
Timestamp.newBuilder().setSeconds(now.getEpochSecond())
.setNanos(now.getNano()).build();
Example 6: Compute Timestamp from current time in Python.
timestamp = Timestamp()
timestamp.GetCurrentTime()
# JSON Mapping
In JSON format, the Timestamp type is encoded as a string in the
[RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format. That is, the
format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z"
where {year} is always expressed using four digits while {month}, {day},
{hour}, {min}, and {sec} are zero-padded to two digits each. The fractional
seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution),
are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone
is required. A proto3 JSON serializer should always use UTC (as indicated by
"Z") when printing the Timestamp type and a proto3 JSON parser should be
able to accept both UTC and other timezones (as indicated by an offset).
For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past
01:30 UTC on January 15, 2017.
In JavaScript, one can convert a Date object to this format using the
standard
[toISOString()](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/toISOString)
method. In Python, a standard `datetime.datetime` object can be converted
to this format using
[`strftime`](https://docs.python.org/2/library/time.html#time.strftime) with
the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use
the Joda Time's [`ISODateTimeFormat.dateTime()`](http://joda-time.sourceforge.net/apidocs/org/joda/time/format/ISODateTimeFormat.html#dateTime()) to obtain a formatter capable of generating timestamps in this format.

